#-------------------------------------------------------------------#
# Mods.Like.pm                                                      #
#-------------------------------------------------------------------#
# Like 4 YaBB2700                                                   #
# Version 0.5                                                       #
# by Carsten Dalgaard                                               #
#-------------------------------------------------------------------#
# Copyright: 2013 'Carsten Dalgaard' - All Rights Reserved          #
# e-mail: post@carsten-dalgaard.dk                                  #
#-------------------------------------------------------------------#
# Any redistribution of this script without the expressed written   #
# consent of 'Carsten Dalgaard' is strictly prohibited. Copying any #
# of the code contained within this script and claiming it as       #
# your own is also prohibited.                                      #
#-------------------------------------------------------------------#
# By using this script you agree to indemnify 'Carsten Dalgaard'    #
# from any liability that might arise from its use.                 #
#-------------------------------------------------------------------#
# You may not remove any of these header notices.                   #
#-------------------------------------------------------------------#
use strict;
use warnings;
use CGI::Carp qw(fatalsToBrowser);
our $VERSION   = '2.7.00';
our $likepmver = 'YaBB 2.7.00 $Revision: 0.5 $';
our ($action);
$action ||= q{};
if ( $action eq 'detailedversion' ) { return 1; }

our (
    %INFO,     $datadir,     %like_txt,      $uid,
    %likename, $iamguest,    %format_unbold, $do_scramble_id,
    $user,     $scripturl,   $yymain,        $yytitle,
    $output,   $yyhtml_root, $usestyle,      $yysetlocation
);

load_language('Mods/Like');

sub LikeList {
    my $to_scrl   = $INFO{'toscrl'};
    my $to_tp     = $INFO{'tobd'};
    my $return_to = qq~num=$to_tp;scrlto=$to_scrl~;
    if ( $INFO{'toboard'} ) {
        $return_to = qq~board=$INFO{'toboard'};scrlto=$to_scrl~;
    }
    else { $return_to = qq~num=$to_tp;scrlto=$to_scrl~; }
    our ($TOPIC);
    fopen( 'TOPIC', '<', "$datadir/$to_tp.txt" )
      || fatal_error( 'cannot_open', "$datadir/$to_tp.txt", 1 );
    my @thread = <$TOPIC>;
    fclose('TOPIC');
    my ( $tpname, undef ) = split /[|]/xsm, $thread[0];
    to_chars($tpname);
    message_totals( 'load', $to_tp );
    my @likes = ();
    {
        no strict qw(refs);
        @likes = split /,/xsm, ${$to_tp}{'like'};
    }
    my $likes   = @likes;
    my $txtlike = number_format($likes);
    my $altlike = $txtlike;
    $altlike .=
      $likes > 1 ? qq~ $like_txt{'likemembers'}~ : qq~ $like_txt{'likemember'}~;
    $altlike .=
      $likes > 1 ? qq~ $like_txt{'liketopic'}~ : qq~ $like_txt{'liketopics'}~;
    my $likeopt = q{};

    for (@likes) {
        load_user($_);
        {
            no strict qw(refs);
            $likename{ ${ $uid . $_ }{'realname'} } =
              "${$uid.$_}{'realname'}|$_";
        }
    }
    my $mlmb = q{};
    for my $tmpmembername (
        sort { lc $likename{$a} cmp lc $likename{$b} }
        keys %likename
      )
    {
        my ( $membername, $memberid ) = split /[|]/xsm,
          $likename{$tmpmembername};
        if ($iamguest) {
            $mlmb = qq~$format_unbold{$memberid}~;
        }
        else {
            if   ($do_scramble_id) { $user = cloak($memberid); }
            else                   { $user = $memberid; }
            $mlmb =
qq~<a href="$scripturl?action=viewprofile;username=$user" target="_blank">$format_unbold{$memberid}</a>~;
        }
        $likeopt .= qq~$mlmb~;
    }
    $yymain = qq~
    <div class="bordercolor" style="width:350px">
    <table class="cs_thin pad_3px">
        <tr>
            <td class="titlebg">
                <span class="small">$altlike:<br />$tpname</span>
            </td>
        </tr><tr>
            <td class="windowbg">
                <div class="windowbg2 likediv">
                $likeopt
                </div>
            </td>
        </tr><tr>
            <td class="windowbg center">
                <input type="button" class="button" onclick="close_return(); window.close()" value="$like_txt{'closewin'}" />
            </td>
        </tr>
    </table>
    </div>

    <script type="text/javascript">
    var scripturl = '$scripturl';
    var returnto = '$return_to';
    function close_return() {
        opener.location.href=scripturl + '?' + returnto;
    }
    </script>
    ~;
    $yytitle = $altlike;
    LikeListtemplate();
    return;
}

sub LikeListtemplate {
    print_output_header();

    $output = << "PAGE";
<!DOCTYPE html>
<html lang="{yabb xml_lang}">
<head>
    <meta charset="{yabb mycharset}">
    <title>$yytitle</title>
    <link rel="stylesheet" href="$yyhtml_root/Templates/Forum/$usestyle.css" type="text/css" />
</head>
<body class="windowbg" style="margin: 0px; padding: 0px;">
    $yymain
</body>
</html>
PAGE

    print_html_output_and_finish();
    return;
}

sub LikeInc {
    if ($iamguest) { fatal_error('no_access'); }
    my $liketopic = $INFO{'thread'};
    message_totals( 'inclike', $liketopic );
    $yysetlocation = qq~$scripturl?num=$liketopic~;
    redirectexit();
    return;
}

sub LikeDec {
    if ($iamguest) { fatal_error('no_access'); }
    my $liketopic = $INFO{'thread'};
    message_totals( 'declike', $liketopic );
    $yysetlocation = qq~$scripturl?num=$liketopic~;
    redirectexit();
    return;
}

1;
